Angular DateTimePicker - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/datetimepicker/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import DateTimePickerModule from smart-webcomponents-angular/datetimepicker: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { DateTimePickerModule } from 'smart-webcomponents-angular/datetimepicker';

4 Root component (standalone)

Add DateTimePickerModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { DateTimePickerComponent } from 'smart-webcomponents-angular/datetimepicker';

import { DateTimePickerModule } from 'smart-webcomponents-angular/datetimepicker';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ DateTimePickerModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('datetimepicker', { read: DateTimePickerComponent, static: false }) datetimepicker!: DateTimePickerComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-date-time-picker as needed:

 <smart-date-time-picker #datetimepicker [calendarButton]="true" [enableMouseWheelAction]="true"
                        [dropDownPosition]="'center-bottom'" [spinButtons]="true" [spinButtonsPosition]="'left'"></smart-date-time-picker>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put DateTimePickerModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put DateTimePickerModule from smart-webcomponents-angular/datetimepicker on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { DateTimePickerModule } from 'smart-webcomponents-angular/datetimepicker';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, DateTimePickerModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Set date range

    Configure min and max selectable dates

    dateTimePicker.min = new Date(2026, 0, 1);
    dateTimePicker.max = new Date(2026, 11, 31);
  • Format display

    Customize the date format shown

    dateTimePicker.formatString = 'yyyy-MM-dd HH:mm';

Troubleshooting

How do I set the date format?
Use the formatString property: formatString = 'yyyy-MM-dd' for ISO format or 'MM/dd/yyyy' for US format.
How do I disable certain dates?
Use the disabledDates property with an array of dates or date ranges to prevent selection.

Accessibility

The DateTimePicker component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React DateTimePicker Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/datetimepicker/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import ReactDOM from 'react-dom/client';
import { DateTimePicker } from 'smart-webcomponents-react/datetimepicker';

const App = () => {
	return (
		<div>
			<DateTimePicker calendarButton enableMouseWheelAction
				dropDownPosition="center-bottom" spinButtons spinButtonsPosition="left"></DateTimePicker>
		</div>
	);
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Set date range

    Configure min and max selectable dates

    dateTimePicker.min = new Date(2026, 0, 1);
    dateTimePicker.max = new Date(2026, 11, 31);
  • Format display

    Customize the date format shown

    dateTimePicker.formatString = 'yyyy-MM-dd HH:mm';

Troubleshooting

How do I set the date format?
Use the formatString property: formatString = 'yyyy-MM-dd' for ISO format or 'MM/dd/yyyy' for US format.
How do I disable certain dates?
Use the disabledDates property with an array of dates or date ranges to prevent selection.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { DateTimePicker, DateTimePickerProps } from 'smart-webcomponents-react/datetimepicker';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The DateTimePicker component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.